
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java技术体验：HTTP多线程下载,端口侦听和自启动服务 / iVAN</title>

    <meta name="description" content="Java技术体验：HTTP多线程下载,端口侦听和自启动服务 一个网友正好需要这个东西,我就把几个技术整合到了一起.包括三个部分,实现时也是逐个做到的 多线程的文件下载,HTTP协议 把这个功能做成一个HTTP的服务,侦听在某个端口上,方便非Java的系统使用 把这个功能封装为一个Windows服务,在机器启动时可以自动启动 我们逐个看程序. 一.多线程下载 这个主要使用了HTTP协议里面的一个Range参数,他设置了你读取数据的其实位置和终止位置. 经常使用flashget的用户在查看连接的详细信息时,应该经常看到这个东西.比如 Range:bytes=">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java技术体验：HTTP多线程下载,端口侦听和自启动服务</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>一个网友正好需要这个东西，我就把几个技术整合到了一起。包括三个部分，实现时也是逐个做到的</p>
<p>多线程的文件下载，HTTP协议</p>
<p>把这个功能做成一个HTTP的服务，侦听在某个端口上，方便非Java的系统使用</p>
<p>把这个功能封装为一个Windows服务，在机器启动时可以自动启动</p>
<p>我们逐个看程序。</p>
<p>一、多线程下载</p>
<p>这个主要使用了HTTP协议里面的一个Range参数，他设置了你读取数据的其实位置和终止位置。 经常使用flashget的用户在查看连接的详细信息时，应该经常看到这个东西。比如</p>
<p>Range:bytes=100-2000</p>
<p>代表从100个字节的位置开始读取，到2000个字节的位置结束，应读取1900个字节。</p>
<p>程序首先拿到文件的长度，然后分配几个线程去分别读取各自的一段，使用了</p>
<p>RandomAccessFile</p>
<p>进行随机位置的读写。</p>
<p>下面是完整的下载的代码。</p>
<p><code>package net.java2000.tools;<br />
import java.io.BufferedInputStream;<br />
import java.io.File;<br />
import java.io.IOException;<br />
import java.io.RandomAccessFile;<br />
import java.net.URL;<br />
import java.net.URLConnection;<br />
/**<br />
* HTTP的多线程下载工具。<br />
*<br />
* @author 赵学庆 www.java2000.net<br />
*/<br />
public class HTTPDownloader extends Thread {<br />
　 // 要下载的页面<br />
　 private String page;<br />
　 // 保存的路径<br />
　 private String savePath;<br />
　 // 线程数<br />
　 private int threadNumber = 2;<br />
　 // 来源地址<br />
　 private String referer;<br />
　 // 最小的块尺寸。如果文件尺寸除以线程数小于这个，则会减少线程数。<br />
　 private int MIN_BLOCK = 10 * 1024;<br />
　 public static void main(String[] args) throws Exception {<br />
　　 HTTPDownloader d = new HTTPDownloader("http://www.xxxx.net/xxxx.rar", "d://xxxx.rar", 10);<br />
　　 d.down();<br />
　 }<br />
　 public void run() {<br />
　　 try {<br />
　　　 down();<br />
　　 } catch (Exception e) {<br />
　　　 e.printStackTrace();<br />
　　 }<br />
　 }<br />
　 /**<br />
　 * 下载操作<br />
　 *<br />
　 * @throws Exception<br />
　 */<br />
　 public void down() throws Exception {<br />
　　 URL url = new URL(page); // 创建URL<br />
　　 URLConnection con = url.openConnection(); // 建立连接<br />
　　 int contentLen = con.getContentLength(); // 获得资源长度<br />
　　 if (contentLen / MIN_BLOCK + 1 &lt; threadNumber) {<br />
　　　 threadNumber = contentLen / MIN_BLOCK + 1; // 调整下载线程数<br />
　　 }<br />
　　 if (threadNumber &gt; 10) {<br />
　　　 threadNumber = 10;<br />
　　 }<br />
　　 int begin = 0;<br />
　　 int step = contentLen / threadNumber;<br />
　　 int end = 0;<br />
　　 for (int i = 0; i &lt; threadNumber; i++) {<br />
　　　 end += step;<br />
　　　 if (end &gt; contentLen) {<br />
　　　　 end = contentLen;<br />
　　　 }<br />
　　　 new HTTPDownloaderThread(this, i, begin, end).start();<br />
　　　 begin = end;<br />
　　 }<br />
　 }<br />
　 public HTTPDownloader() {<br />
　 }<br />
　 /**<br />
　 * 下载<br />
　 *<br />
　 * @param page 被下载的页面<br />
　 * @param savePath 保存的路径<br />
　 */<br />
　 public HTTPDownloader(String page, String savePath) {<br />
　　 this(page, savePath, 10);<br />
　 }<br />
　 /**<br />
　 * 下载<br />
　 *<br />
　 * @param page 被下载的页面<br />
　 * @param savePath 保存的路径<br />
　 * @param threadNumber 线程数<br />
　 */<br />
　 public HTTPDownloader(String page, String savePath, int threadNumber) {<br />
　　 this(page, page, savePath, 10);<br />
　 }<br />
　 /**<br />
　 * 下载<br />
　 *<br />
　 * @param page 被下载的页面<br />
　 * @param savePath 保存的路径<br />
　 * @param threadNumber 线程数<br />
　 * @param referer 来源<br />
　 */<br />
　 public HTTPDownloader(String page, String referer, String savePath, int threadNumber) {<br />
　　 this.page = page;<br />
　　 this.savePath = savePath;<br />
　　 this.threadNumber = threadNumber;<br />
　　 this.referer = referer;<br />
　 }<br />
　 public String getPage() {<br />
　　 return page;<br />
　 }<br />
　 public void setPage(String page) {<br />
　　 this.page = page;<br />
　 }<br />
　 public String getSavePath() {<br />
　　 return savePath;<br />
　 }<br />
　 public void setSavePath(String savePath) {<br />
　　 this.savePath = savePath;<br />
　 }<br />
　 public int getThreadNumber() {<br />
　　 return threadNumber;<br />
　 }<br />
　 public void setThreadNumber(int threadNumber) {<br />
　　 this.threadNumber = threadNumber;<br />
　 }<br />
　 public String getReferer() {<br />
　　 return referer;<br />
　 }<br />
　 public void setReferer(String referer) {<br />
　　 this.referer = referer;<br />
　 }<br />
}<br />
/**<br />
* 下载线程<br />
*<br />
* @author 赵学庆 www.java2000.net<br />
*/<br />
class HTTPDownloaderThread extends Thread {<br />
　 HTTPDownloader manager;<br />
　 int startPos;<br />
　 int endPos;<br />
　 int id;<br />
　 int curPos;<br />
　 int BUFFER_SIZE = 4096;<br />
　 int readByte = 0;<br />
　 HTTPDownloaderThread(HTTPDownloader manager, int id, int startPos, int endPos) {<br />
　　 this.id = id;<br />
　　 this.manager = manager;<br />
　　 this.startPos = startPos;<br />
　　 this.endPos = endPos;<br />
　 }<br />
　 public void run() {<br />
　　 // System.out.println("线程" + id + "启动");<br />
　　 // 创建一个buff<br />
　　 BufferedInputStream bis = null;<br />
　　 RandomAccessFile fos = null;<br />
　　 // 缓冲区大小<br />
　　 byte[] buf = new byte[BUFFER_SIZE];<br />
　　 URLConnection con = null;<br />
　　 try {<br />
　　　 File file = new File(manager.getSavePath());<br />
　　　 // 创建RandomAccessFile<br />
　　　 fos = new RandomAccessFile(file, "rw");<br />
　　　 // 从startPos开始<br />
　　　 fos.seek(startPos);<br />
　　　 // 创建连接,这里会为每个线程都创建一个连接<br />
　　　 URL url = new URL(manager.getPage());<br />
　　　 con = url.openConnection();<br />
　　　 con.setAllowUserInteraction(true);<br />
　　　 curPos = startPos;<br />
　　　 // 设置获取资源数据的范围,从startPos到endPos<br />
　　　 con.setRequestProperty("Range", "bytes=" + startPos + "-" + endPos);<br />
　　　 // 盗链解决<br />
　　　 con.setRequestProperty("referer", manager.getReferer() == null ? manager.getPage() : manager.getReferer());<br />
　　　 con.setRequestProperty("userAgent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)");<br />
　　　 // 下面一段向根据文件写入数据,curPos为当前写入的未知,这里会判断是否小于endPos,<br />
　　　 // 如果超过endPos就代表该线程已经执行完毕<br />
　　　 bis = new BufferedInputStream(con.getInputStream());<br />
　　　 while (curPos &lt; endPos) {<br />
　　　　 int len = bis.read(buf, 0, BUFFER_SIZE);<br />
　　　　 if (len == -1) {<br />
　　　　　 break;<br />
　　　　 }<br />
　　　　 fos.write(buf, 0, len);<br />
　　　　 curPos = curPos + len;<br />
　　　　 if (curPos &gt; endPos) {<br />
　　　　　 // 获取正确读取的字节数<br />
　　　　　 readByte += len - (curPos - endPos) + 1;<br />
　　　　 } else {<br />
　　　　　 readByte += len;<br />
　　　　 }<br />
　　　 }<br />
　　　 // System.out.println("线程" + id + "已经下载完毕:" + readByte);<br />
　　　 bis.close();<br />
　　　 fos.close();<br />
　　 } catch (IOException ex) {<br />
　　　 ex.printStackTrace();<br />
　　 }<br />
　 }<br />
}</code></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 22:28:25</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/this/" title="this">this</a>, <a href="https://www.iamivan.net/tag/int/" title="int">int</a>, <a href="https://www.iamivan.net/tag/page/" title="page">page</a>, <a href="https://www.iamivan.net/tag/java%e4%b8%adreference/" title="java中reference">java中reference</a>, <a href="https://www.iamivan.net/tag/randomaccessfile%e6%b5%81/" title="randomaccessfile流">randomaccessfile流</a>, <a href="https://www.iamivan.net/tag/java-%e4%b8%8b%e8%bd%bd-url/" title="java 下载 url">java 下载 url</a>, <a href="https://www.iamivan.net/tag/java-%e5%9b%be%e7%89%87-%e4%b8%8b%e8%bd%bd-%e7%ba%bf%e7%a8%8b/" title="java 图片 下载 线程">java 图片 下载 线程</a>, <a href="https://www.iamivan.net/tag/httpdownload/" title="httpdownload">httpdownload</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java技术体验：HTTP多线程下载,端口侦听和自启动服务的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2ZA9rb.html" rel="bookmark">JAVA技术实现上传下载文件到FTP服务器&lpar;完整&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				具体详细介绍请看下文: 在使用文件进行交互数据的应用来说,使用FTP服务器是一个很好的选择.本文使用Apache Jakarta Commons Net(commons-net-3.3.jar) 基于FileZilla Server服务器实现FTP服务器上文件的上传/下载/删除等操作. 关于FileZilla Server服务器的详细搭建配置过程,详情请见 FileZilla Server安装配置教程 .之前有朋友说,上传大文件(几百M以上的文件)到FTP服务器时会重现无法重命名的问题,但本人亲			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQLLLQz.html" rel="bookmark">Java 仿迅雷多线程下载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package net.webjoy.jackluo.android_json; /** * 1.http Range &quot;bytes=&quot;+ start+end * 2.RandomAccessFile设置写入的位置 * 3开启多线程下载 * * Created by jackluo on 9/30/15. */ import android.os.Environment; import android.os.Handler; import android.os.Message; imp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoElOb.html" rel="bookmark">java 多线程-为什么使用Java多线程下载文件时下载后的文件和服务器端文件大小一模一样但是无法打开</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 为什么使用Java多线程下载文件时下载后的文件和服务器端文件大小一模一样但是无法打开 为什么使用Java多线程下载文件时下载后的文件和服务器端文件大小一模一样但是无法打开?? package com.miuitust.mutilethread; import java.io.File; import java.io.InputStream; import java.io.RandomAccessFile; import java.net.HttpURLConnection; impor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPl4XZp.html" rel="bookmark">java多线程下载实例详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了java多线程下载.分享给大家供大家参考,具体如下: 使用多线程下载文件可以更快完成文件的下载,多线程下载文件之所以快,是因为其抢占的服务器资源多.如:假设服务器同时最多服务100个用户,在服务器中一条线程对应一个用户,100条线程在计算机中并非并发执行,而是由CPU划分时间片轮流执行,如果A应用使用了99条线程下载文件,那么相当于占用了99个用户的资源,假设一秒内CPU分配给每条线程的平均执行时间是10ms,A应用在服务器中一秒内就得到了990ms的执行时间,而其他应用在一秒内只			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwyJQdM.html" rel="bookmark">java多线程下载和断点续传</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  java多线程下载和断点续传,示例代码只实现了多线程,断点只做了介绍.但是实际测试结果不是很理想,不知道是哪里出了问题.所以贴上来请高手修正. [Java]代码 import java.io.File; import java.io.IOException; import java.io.RandomAccessFile; import java.net.HttpURLConnection; import java.net.URL; public class DownloadFile { /			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2WZ14M.html" rel="bookmark">我的Java开发学习之旅------&amp;amp&semi;gt&semi;Java多线程下载文件  实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				import java.io.File; import java.io.InputStream; import java.io.RandomAccessFile; import java.net.HttpURLConnection; import java.net.URL; public class MulThreadDownload { public static void main(String[] args) throws Exception { String path = &quot;http:/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVGBRnb.html" rel="bookmark">Java多线程下载的实现方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: package cn.me.test; import java.io.InputStream; import java.io.RandomAccessFile; import java.net.HttpURLConnection; import java.net.URL; /**  * 多线程下载  * 1:使用RandomAccessFile在任意的位置写入数据.  * 2:需要计算第一个线程下载的数据量,可以平均分配.如果不够平均时,  *    则直接最后一个线程处理			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeRxk0b.html" rel="bookmark">android多线程下载3</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天跟大家一起分享下android开发中比较难的一个环节,可能很多人看到这个标题就会感觉头很大,的确如果没有良好的编码能力和逻辑思维,这块是很难搞明白的,前面2次总结中已经为大家分享过有关技术的一些基本要领,我们先一起简单回顾下它的基本原理. http://blog.csdn.net/shimiso/article/details/6763664  android 多线程断点续传下载 一 http://blog.csdn.net/shimiso/article/details/6763986 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boYwjp.html" rel="bookmark">Java 程序中的多线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|多线程 在Java程序中使用多线程要比在 C 或 C++ 中容易得多,这是因为 Java 编程语言提供了语言级的支持.本文通过简单的编程示例来说明 Java 程序中的多线程是多么直观.读完本文以后,用户应该能够编写简单的多线程程序. 为什么会排队等待? 下面的这个简单的 Java 程序完成四项不相关的任务.这样的程序有单个控制线程,控制在这四个任务之间线性地移动.此外,因为所需的资源 - 打印机.磁盘.数据库和显示屏 -- 由于硬件和软件的限制都有内在的潜伏时间,所以每项任务都包含			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8GQ9M.html" rel="bookmark" class="title">PHP针对配置文件操作的最常用四个ini函数</a>
					<div>
						php的配置函数就是几个ini_*的函数,主要是针对配置文件的操作,其实就四个函数:ini_get.ini_set.ini_get_all.ini_restore.个人感觉最有用的就是ini_set和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPed8z.html" rel="bookmark" class="title">java JDBC 提高程序可移植性</a>
					<div>
						程序 很多java初学者在开始接触JDBC编程的时候,在网上和大部分的教材上都是这样介绍JDBC一般的程序://可以运行的完整程序import java.sql.*; public class Dat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVlRlM.html" rel="bookmark" class="title">VS2005Beta2安装几点经验和体会</a>
					<div>
						 说说几点注意事项和体会: 1.VS2003的J#发布包安装后是可以卸载的,VS2005的不行,卸载后进入主界会有出错警告,忽略它也可以正常进行C#等程序的编写,没发现有啥影响.但始终不太爽. 2.M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxmKyp.html" rel="bookmark" class="title">中文Access2000速成教程--目录</a>
					<div>
						access|教程|速成|中文 使用中文Access 2000可以从单一的数据库文件中组织用户信息.在此文件中,可将数据分开放在名为&quot;表&quot;,也就是前面所说的&quot;数据表&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaRVqM.html" rel="bookmark" class="title">SEO最佳实践：页面搜索引擎优化清单</a>
					<div>
						详细介绍八种对SEO页面优化的最佳实践方法. 第一. 标题标签 这是页上最重要的SEO因素之一.标题标签告诉搜索引擎哪些网页,在您的网站上的页面是相关的关键字或关键字词组.标题标签应该是唯一的一页.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqw0Kz.html" rel="bookmark" class="title">一段找出URL的代码（C&num;）</a>
					<div>
						string str=&quot;wecncnc&lt;a href=\&quot;list.asp?Page=1&amp;boardid=33&amp;t=656727&amp;p=11&amp;t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY21Wxp.html" rel="bookmark" class="title">python中argparse模块用法实例详解</a>
					<div>
						  本文实例讲述了python中argparse模块用法.分享给大家供大家参考.具体分析如下: 平常在写命令行工具的时候,经常会带参数,所以用python中的argparse来实现. ? 1 2 3  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWX43qp.html" rel="bookmark" class="title">新MacBook怎么使用PPPoe拨号有线上网？</a>
					<div>
						  准备工作:USB Type-C接头转接普通网口转接口 新MacBook使用PPPoe拨号有线上网详细教程 1.安装双绞线和USB以太网卡,安装到macbook上. 2.点击网络连接的图标,打开网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB7NVz.html" rel="bookmark" class="title">阿里怎么发工资？自研薪酬管理系统首次曝光</a>
					<div>
						人力资源管理系统是用集中的数据将几乎所有的人力资源相关的信息(组织.招聘.薪资.绩效.审批等)统一管理起来,是企业运行必不可少的管理软件.国际上知名的有Oracle PeopleSoft.SAP 和W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdELy6z.html" rel="bookmark" class="title">关于在MFC中将窗口最小化到托盘实现原理及操作步骤&lowbar;C 语言</a>
					<div>
						步骤/方法 (一) 原理 1.最小化的原理:首先要将窗口隐藏,然后在右下角绘制图标. 2.恢复的原理:将窗口显示,再将托盘中的图片删除. (二)程序实现 1.自定义消息WM_SHOWTASK: #de ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6e56M.html" rel="bookmark" class="title">php对于带有验证码的模拟登陆</a>
					<div>
						问题描述 php对于带有验证码的模拟登陆 学校网站:http://jwgl.nchu.edu.cn/(A(dwUI5Kdz0AEkAAAAODAzYTNmOTctOTA3ZS00NmJiLThhZDY ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA7aeM.html" rel="bookmark" class="title">ASP&period;NET 点击按钮 action获取数据</a>
					<div>
						问题描述 我系统尝试下同步表单提交的时候,能否将按钮所在行的数据提交到后台,并且后台actino能获取submit按钮的属性值,例如name.tooltip等以下是代码:@if(ViewData[&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRGoKp.html" rel="bookmark" class="title">批处理方式实现的目录比较工具&lowbar;DOS&sol;BAT</a>
					<div>
						更新日志: v4: 1.增加了计算的进度显示: 2.找了新版的 md5sum.exe,没有对动态库的依赖. 工具一:md5comv4.bat 接受两个目录参数,计算两个目录里每个文件的 md5 值,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB5lqb.html" rel="bookmark" class="title">java 使用进度条progressbar显示更新的问题，不能同步</a>
					<div>
						问题描述 听说要想在一个frame上面,在点了一按钮的同时用progressbar进度条来显示操作的进度,得用个多线程处理.我也不要求这进度条显示多少百分比,就只要在那方法进行的时候来回摆动就行了.任 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE456Zz.html" rel="bookmark" class="title">Wamp配置mysql编码</a>
					<div>
						      因为之前做.net的时候,玩了玩儿PHP,所以用的wamp server 一直在,后来做java项目,也就一直用着上面的mysql.       但是中间出现过好几次乱码,额,今天又改了改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RwqJz.html" rel="bookmark" class="title">果壳发布两款魔豆路由器，并推出&OpenCurlyDoubleQuote;魔豆按钮&rdquo;智能家居配件</a>
					<div>
						        今天下午, 果壳电子在北京正式发布了其内测了近半年的路由器产品. 正式发布的有两款路由,改用&quot;魔豆&quot;品牌,分别叫魔豆路由器.魔豆路由器LITE. 其中,魔豆路由器的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKgDAz.html" rel="bookmark" class="title">服务系统数据的一致性：可靠事件</a>
					<div>
						微服务架构解决了很多问题,但是同时引入了很多问题.设计到系统,其中绕不开的就是数据一致性,从本地事务,到后来的分布式事务,都能够有效的保证数据一致性.但是在微服务架构中,这两种方式都不是最好的选择.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB17V4z.html" rel="bookmark" class="title">如何编写一个独立的PHP扩展</a>
					<div>
						独立的 PHP 扩展可以独立于 PHP 源码之外进行分发.要创建一个这样的扩展,需要准备好两样东西: 配置文件 (config.m4) 你的模块源码 接下来我们来描述一下如果创建这些文件并组合起来.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqgj8p.html" rel="bookmark" class="title">金蝶K3开发</a>
					<div>
						问题描述 金蝶K3能否用C#语言进行二次开发? 解决方案 解决方案二:楼主想要开发什么功能?解决方案三:外挂,什么语言都可以呀.解决方案四:比如我需要对K3里面的即时库存进行重新开发,打算用写个VB插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgW5dM.html" rel="bookmark" class="title">消息称平安银行或明年2月注销 近期曾出重大系统故障</a>
					<div>
						备受市场关注的&quot;平深恋&quot;又有新进展.10月9日消息,新浪财经今日从平安银行和深发展银行内部人士获悉,深发展将继续发展,而平安银行将被注销,时间或在明年2月. 上述内部人士透露,&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX8B6b.html" rel="bookmark" class="title">苹果申请新型显示屏专利可切换彩屏&sol;黑白屏</a>
					<div>
						苹果申请新型显示屏专利 可切换彩屏/黑白屏 北京时间4月8日上午消息,科技博客AppleInsider报道,根据苹果日前提交给美国专利与商标局的专利申请,该公司有意开发一种新型显示屏,可以将全彩色或部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0Lnxp.html" rel="bookmark" class="title">苹果开发之ios 验证码倒计时</a>
					<div>
						第一步,拖两个空间textfiled和button到storyboard上的viewcontroller上. 开发之ios 验证码倒计时-ios开发验证码倒计时&quot;&gt; 第二步,拖线,链接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkJkQz.html" rel="bookmark" class="title">线上第五大道</a>
					<div>
						纽约曼哈顿中央街区的第五大道,阳光映射下泛着亮光的高楼大厦矗立在路旁,街道上,CHANEL.GUCCI.TIFFANY等名店一字排开.世界上很少有街道能像第五大道那样,可以聚集如此众多货品齐全.备受追 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8jdrb.html" rel="bookmark" class="title">WebDAV访问问题</a>
					<div>
						问题描述 Exchange2003,首先用下面的代码,自动创建用户ABC,然后用WebDAV去访问http://localhost/exchange/ABC/,出现错误:Theremoteserver ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Qngqp.html" rel="bookmark" class="title">请问如何查看自己的notes邮箱容量？</a>
					<div>
						问题描述 如题,谢谢~~~~~~~~~~~~~~~~~~~ 解决方案 解决方案二:这个,是服务器分配的吧......解决方案三:DimsessionAsNewNotesSessionDimdbAsNo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvWqOM.html" rel="bookmark" class="title">已知对角线的两点 判读给出的任意一个点 在不在矩形范围内</a>
					<div>
						问题描述 已知对角线的两点判读给出的任意一个点在不在矩形范围内.这个方法用java具体应该怎么写?求帮助! 解决方案 解决方案二:介是作业吗?解决方案三:项目中需要用到这个方法,可是我不会写啊!解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YN7Rp.html" rel="bookmark" class="title">find ontour-findContour老出错，怎么回事</a>
					<div>
						问题描述 findContour老出错,怎么回事 void FindMarker(Mat img){ vector&lt;vector&lt;Point&gt; &gt; contours;findC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG1R86M.html" rel="bookmark" class="title">SEO中几个容易被忽略的技巧</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 相信各位SEOer接触SEO也不是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0N7LM.html" rel="bookmark" class="title">System&period;Web&period;UI&period;WebControls&period;TreeNode 没有 DataBinding 事件</a>
					<div>
						问题描述 &lt;asp:TreeNodeText=&quot;业务部&quot;Value=&quot;业务部&quot;NavigateUrl='&lt;%#&quot;~/Work/SumUp. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVXZXkM.html" rel="bookmark" class="title">地方装修网走细分运营之路也能实现小市场大利润</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 地方装修网已经是细分中的细分网站, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
